From 8a417e1ef2a687c23adcb2f34d8974a34c35a118 Mon Sep 17 00:00:00 2001
From: Patrick Monnerat <patrick@monnerat.net>
Date: Mon, 13 Feb 2023 08:33:09 +0100
Subject: content_encoding: do not reset stage counter for each header

Test 418 verifies

Closes #10492
---
 lib/content_encoding.c | 7 +++----
 lib/urldata.h          | 1 +
 2 files changed, 4 insertions(+), 4 deletions(-)

diff --git a/lib/content_encoding.c b/lib/content_encoding.c
index e646f310e..fd0ca8a1e 100644
--- a/lib/content_encoding.c
+++ b/lib/content_encoding.c
@@ -944,7 +944,6 @@ CURLcode Curl_build_unencoding_stack(struct connectdata *conn,
 {
   struct Curl_easy *data = conn->data;
   struct SingleRequest *k = &data->req;
-  int counter = 0;
 
   do {
     const char *name;
@@ -979,9 +978,9 @@ CURLcode Curl_build_unencoding_stack(struct connectdata *conn,
       if(!encoding)
         encoding = &error_encoding;  /* Defer error at stack use. */
 
-      if(++counter >= MAX_ENCODE_STACK) {
-        failf(data, "Reject response due to %u content encodings",
-              counter);
+      if(k->writer_stack_depth++ >= MAX_ENCODE_STACK) {
+        failf(data, "Reject response due to more than %u content encodings",
+              MAX_ENCODE_STACK);
         return CURLE_BAD_CONTENT_ENCODING;
       }
       /* Stack the unencoding stage. */
diff --git a/lib/urldata.h b/lib/urldata.h
index ff3cc9a65..19930a7d1 100644
--- a/lib/urldata.h
+++ b/lib/urldata.h
@@ -628,6 +628,7 @@ struct SingleRequest {
   void *protop;       /* Allocated protocol-specific data. Each protocol
                          handler makes sure this points to data it needs. */
   struct dohdata doh; /* DoH specific data for this request */
+  unsigned char writer_stack_depth; /* Unencoding stack depth. */
 };
 
 /*
-- 
2.30.2

